<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: ControladorPersona.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: ControladorPersona.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>'use strict';
var models = require('./../models/');
var persona = models.persona;
var cuenta = models.usuario;
var artista = models.artista;
var uuid = require('uuid');
var formidable = require('formidable');
var extensiones = ["jpg", "png", "jpeg"];
var maxSize = 16 * 1024 * 1024;
var fs = require('fs');

/**
 * @class ControladorPersona
 */
class ControladorPersona {
    /**
     * @description Método para guardar los datos de un nuevo usuario. En esta tabla se relacionan las tablas de persona, cuenta y artista, ya que se guardará información de los tres al mismo tiempo
     * @param {req} req Sirve para obtener los datos todos los datos necesarios para registrar un nuevo usuario, y para presentar los mensajes de error o de información
     * @param {res} res Sirve para redireccionar a la ventana de inicio de sesión en el caso de que el usuario se registre correctamente, y en el caso de error lo devolverá a la ventana de registro
     */
    guardar(req, res) {
        var correo = req.body.correo;
        var nombre = req.body.nombres_artista;
        cuenta.findOne({where: {correo: correo}}).then(function (datoscuenta) {
            if (datoscuenta === null) {
                artista.findOne({where: {nom_artista: nombre}}).then(function (datosartista) {
                    if (datosartista === null) {
                        var datos = {
                            apellidos: req.body.apellidos,
                            nombres: req.body.nombres,
                            fecha_nac: req.body.fecha,
                            telefono: req.body.celular,
                            foto: 'logon.png',
                            id_rol: 2,
                            external_id: uuid.v4(),
                            usuario: {
                                correo: req.body.correo,
                                clave: req.body.clave,
                                estado: true,
                                external_id: uuid.v4()

                            },
                            artista: {
                                nom_artista: req.body.nombres_artista,
                                tipo_artista: req.body.tipo_artista,
                                external_id: uuid.v4()
                            }
                        };
                        persona.create(datos, {include: [{model: models.usuario, as: 'usuario'}, {model: models.artista, as: 'artista'}]}).then(function (PersonaDatos) {
                            req.flash('info', "Se ha registrado correctamente");
                            res.redirect("/");
                        }).error(function (error) {
                            req.flash('error', 'Error al registrar');
                            res.redirect('/registro');
                        });
                    } else {
                        req.flash('error', 'El nombre de artista ya ha sido ocupado');
                        res.redirect('/registro');
                    }
                });
            } else {
                req.flash('error', 'Usted ya se ha registrado en el sitio web.');
                res.redirect('/registro');
            }
        });
    }

    /**
     * @description Método que permite visulizar la ventana Perfil, en la cuál el usuario podrá ver todos sus datos al momento de registrarse
     * @param {req} req Sirve para presentar los mensajes de error o de información
     * @param {res} res Sirve para redireccionar a la ventana Perfil, y en el caso de que exista un error, redireccione a la ventana principal
     */
    visualizar_perfil(req, res) {
        var persona = models.persona;
        var external = req.user.id;
        persona.findAll({where: {external_id: external}, include: [{model: models.usuario, as: 'usuario'}, {model: models.artista, as: 'artista'}]}).then(function (Datos) {
            res.render('index',
                    {
                        title: 'Aureo | Perfil',
                        fragmentos: "Perfil",
                        info: Datos[0],
                        msg: {error: req.flash('error'), info: req.flash('info')}

                    });
        }).error(function (error) {
            req.flash('error', 'Hubo un problema, comunicate con tu servicio del sistema');
            res.redirect('/');
        });
    }

    /**
     * @description Método que permite visulizar la ventana ModificarPerfil, en la cuál el usuario podrá editar sus datos personales
     * @param {req} req Sirve para obtener el external id de la persona, y también presentar los mensajes de información o error
     * @param {res} res Sirve para direccionar a la ventana ModificarPerfil, y en el caso de que exista algún error, redireccionar a la ventana principal
     */
    visualizar_modificar(req, res) {
        var external = req.user.id;
        persona.findAll({where: {external_id: external}, include: [{model: models.usuario, as: 'usuario'}, {model: models.artista, as: 'artista'}]}).then(function (Datos) {
            res.render('index',
                    {
                        title: 'Aureo | Modificar Perfil',
                        fragmentos: "ModificarPerfil",
                        info: Datos[0],
                        msg: {error: req.flash('error'), info: req.flash('info')}

                    });
        }).error(function (error) {
            req.flash('error', 'Hubo un problema, comunicate con tu servicio del sistema');
            res.redirect('/');
        });
    }

    /**
     * @description Método para modificar los datos personales del usuario
     * @param {req} req Sirve para obtener el external id de la persona, el nombre del artista
     * @param {res} res Sirve para redireccionar a la ventana Perfil en el caso de que exista algún error, o de que todo se haya completado correctamente
     */
    modificar_perfil(req, res) {
        var external = req.user.id;
        persona.findAll({where: {external_id: external}, include: [{model: models.usuario, as: 'usuario'}, {model: models.artista, as: 'artista'}]}).then(datos => {
            if (datos.length > 0) {
                var Datos = datos[0];

                Datos.apellidos = req.body.apellidos;
                Datos.nombres = req.body.nombres;
                Datos.fecha_nac = cambiarFechaparaGuardar(req.body.fecha);
                Datos.telefono = req.body.celular;
                Datos.save().then(function (result) {
                    var DatosU = Datos.usuario;
                    DatosU.correo = req.body.correo;
                    DatosU.clave = req.body.clave;
                    DatosU.save().then(function (result) {
                        var DatosA = Datos.artista;
                        DatosA.nom_artista = req.body.nombres_artista;
                        DatosA.tipo_artista = req.body.tipo_artista;
                        DatosA.save().then(function (result) {
                            req.flash('info', 'Se ha modificado correctamente');
                            res.redirect('/perfil');
                        }).error(function (error) {
                            req.flash('error', 'No se pudo modificar');
                            res.redirect('/perfil');
                        });
                    }).error(function (error) {
                        req.flash('error', 'No se pudo modificar');
                        res.redirect('/perfil');
                    });
                }).error(function (error) {
                    req.flash('error', 'No se pudo modificar');
                    res.redirect('/perfil');
                });
            } else {
                req.flash('error', 'No se pudo modificar');
                res.redirect('/perfil');
            }
        });
    }

    /**
     * @description Método para visualizar la ventana EditarFotoPerfil, en la cuál el usuario podrá subir un archivo de imagen, para usarlo como su foto de perfil
     * @param {req} req Sirve para obtener el external id de la persona, y para presentar los mensajes de error o de información
     * @param {res} res Sirve para redireccionar a la ventana de EditarFotoPerfil, y en el caso de error lo devolverá a la ventana de perfil
     */
    visualizar_foto_perfil(req, res) {
        var external = req.params.external;
        persona.findOne({where: {external_id: external}}).then(function (Datos) {
            res.render('index',
                    {
                        title: 'Aureo | Editar Portada del Album',
                        fragmentos: "EditarFotoPerfil",
                        info: Datos,
                        external: external,
                        msg: {error: req.flash('error'), info: req.flash('info')}

                    });
        }).error(function (error) {
            req.flash('error', 'Hubo un problema, comunicate con tu servicio del sistema');
            res.redirect('/perfil');
        });
    }

    /**
     * @description Método para guardar la foto de perfil que el usuario suba a la plataforma
     * @param {req} req Sirve para presentar los mensajes respectivos de información o de error, y también para obtener la imagen que el usuario haya subido en el input llamado "foto"
     * @param {res} res Sirve para redireccionar a la ventana de Perfil en el caso de que se guarde correctamente, o de que exista algún error
     */
    guardar_foto(req, res) {
        var form = new formidable.IncomingForm();
        form.parse(req, function (err, fields, files) {
            if (files.foto.size &lt;= maxSize) {
                var extension = files.foto.name.split(".").pop().toLowerCase();
                if (extensiones.includes(extension)) {
                    var external = fields.external;
                    var nombreFoto = external + "." + extension;
                    fs.rename(files.foto.path, "public/fotos_perfil/" + nombreFoto,
                            function (err) {
                                if (err) {
                                    req.flash('error', "Hubo un error " + err);
                                    res.redirect("/perfil");
                                } else {
                                    persona.findOne({where: {external_id: external}}).then(function (result) {
                                        result.foto = nombreFoto;
                                        result.save().then(function (ok) {
                                            fs.exists(files.foto.path, function (exists) {
                                                if (exists)
                                                    fs.unlinkSync(files.foto.path);
                                            });
                                            req.flash('info', "Se ha cambiado su foto de perfil");
                                            res.redirect("/perfil");
                                        });

                                    });
                                }
                            });
                } else {
                    req.flash('error', "El tipo de archivo no es valido, debe ser png, jpg, o jpeg");
                    res.redirect("/perfil");
                }
            } else {
                req.flash('error', "El tamano no puede superar 1 MB");
                res.redirect("/perfil");
            }
        });
    }
}

/**
 * @description Obtiene la fecha de nacimiento del usuario y la transforma al formato que guarda la base de datos
 * @param {date} fecha_recibida Es la fecha que se obtiene  
 * @returns {fecha} Devuelve la fecha transformada
 */
function cambiarFechaparaGuardar(fecha_recibida) {
    var d = new Date(fecha_recibida);
    var mes = contar_cero((d.getMonth() + 1), 2);
    var dias = contar_cero(d.getDate(), 2);
    var fecha = (d.getFullYear() + "-" + mes + "-" + dias);
    return fecha;
}

/**
 * @description Trabaja junto a la función cambiarFechaparaGuardar, para transformar los meses y días al formato permitido por mysql
 * @param {int} texto Es el número de la fecha obtenida
 * @param {int} nro_cero Es el número de ceros que se necesita
 * @returns {String} Devuelve una cadena con los números de la fecha con el formato correspondiente
 */
function contar_cero(texto, nro_cero) {
    texto = texto + "";
    var longi = texto.length;
    var aux = nro_cero - longi;
    var cadena = "";
    if (aux &lt; nro_cero) {
        for (var i = longi; i &lt; nro_cero; i++) {
            cadena += '0';
        }
        cadena += texto;
        return cadena;
    } else {
        return texto;
    }
}


module.exports = ControladorPersona;</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="ControladorPersona.html">ControladorPersona</a></li></ul><h3>Global</h3><ul><li><a href="global.html#cambiarFechaparaGuardar">cambiarFechaparaGuardar</a></li><li><a href="global.html#contar_cero">contar_cero</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Sun Aug 25 2019 04:13:16 GMT-0500 (GMT-05:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
